    001    /* ===========================================================
    002     * JFreeChart : a free chart library for the Java(tm) platform
    003     * ===========================================================
    004     *
    005     * (C) Copyright 2000-2005, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jfreechart/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025     * in the United States and other countries.]
    026     *
    027     * ------------------------
    028     * DefaultValueDataset.java
    029     * ------------------------
    030     * (C) Copyright 2003-2005, by Object Refinery Limited.
    031     *
    032     * Original Author:  David Gilbert (for Object Refinery Limited);
    033     * Contributor(s):   -;
    034     *
    035     * $Id $
    036     *
    037     * Changes
    038     * -------
    039     * 27-Mar-2003 : Version 1 (DG);
    040     * 18-Aug-2003 : Implemented Cloneable (DG);
    041     * 03-Mar-2005 : Implemented PublicCloneable (DG);
    042     *
    043     */
    044
    045    package org.jfree.data.general;
    046
    047    import java.io.Serializable;
    048
    049    import org.jfree.util.ObjectUtilities;
    050    import org.jfree.util.PublicCloneable;
    051
    052    /**
    053     * A dataset that stores a single value.  This class provides a default
    054     * implementation of the {@link ValueDataset} interface.
    055     */
    056    public class DefaultValueDataset extends AbstractDataset
    057                                     implements ValueDataset,
    058                                                Cloneable, PublicCloneable,
    059                                                Serializable {
    060
    061        /** For serialization. */
    062        private static final long serialVersionUID = 8137521217249294891L;
    063
    064        /** The value. */
    065        private Number value;
    066
    067        /**
    068         * Constructs a new dataset, initially empty.
    069         */
    070        public DefaultValueDataset() {
    071            this(null);
    072        }
    073
    074        /**
    075         * Creates a new dataset.
    076         *
    077         * @param value  the value.
    078         */
    079        public DefaultValueDataset(double value) {
    080            this(new Double(value));
    081        }
    082
    083        /**
    084         * Creates a new dataset.
    085         *
    086         * @param value  the initial value.
    087         */
    088        public DefaultValueDataset(Number value) {
    089            this.value = value;
    090        }
    091
    092        /**
    093         * Returns the value.
    094         *
    095         * @return The value (possibly <code>null</code>).
    096         */
    097        public Number getValue() {
    098            return this.value;
    099        }
    100
    101        /**
    102         * Sets the value and sends a {@link DatasetChangeEvent} to all registered
    103         * listeners.
    104         *
    105         * @param value  the new value (<code>null</code> permitted).
    106         */
    107        public void setValue(Number value) {
    108            this.value = value;
    109            notifyListeners(new DatasetChangeEvent(this, this));
    110        }
    111
    112        /**
    113         * Tests this dataset for equality with an arbitrary object.
    114         *
    115         * @param obj  the object.
    116         *
    117         * @return A boolean.
    118         */
    119        public boolean equals(Object obj) {
    120
    121            if (obj == null) {
    122                return false;
    123            }
    124
    125            if (obj == this) {
    126                return true;
    127            }
    128
    129            if (obj instanceof ValueDataset) {
    130                ValueDataset vd = (ValueDataset) obj;
    131                return ObjectUtilities.equal(this.value, vd.getValue());
    132            }
    133
    134            return false;
    135        }
    136
    137        /**
    138         * Returns a hash code.
    139         *
    140         * @return A hash code.
    141         */
    142        public int hashCode() {
    143            return (this.value != null ? this.value.hashCode() : 0);
    144        }
    145
    146    }